unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, VclTee.TeeGDIPlus,
  VCLTee.Series, VCLTee.TeEngine, Vcl.ExtCtrls, VCLTee.TeeProcs, VCLTee.Chart,
  Vcl.Buttons, system.UITypes, system.Math;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    LabeledEdit1: TLabeledEdit;
    BitBtn1: TBitBtn;
    LabeledEdit2: TLabeledEdit;
    Chart1: TChart;
    Series1: TLineSeries;
    Series2: TLineSeries;
    Series3: TPointSeries;
    Series4: TPointSeries;
    CheckBox1: TCheckBox;
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
const

//xk[CB(2)AB(4)AB(6)A...AB(16)

  B : array[1..8] of double = ( 1.0 / 6,           // B(2)
                                  -1.0 / 30,
                                   1.0 / 42,
                                  -1.0 / 30,
                                   5.0 / 66,
                                -691.0 / 2730,
                                   7.0 / 6,
                               -3617.0 / 510);     // B(16)

  m: integer = sizeof(B) div sizeof(double);

function Gamma(x: double): double;  // K}֐
var
  i : integer;
  sum : double;
  xx, v  : double;
  xj  : double;
  lng : double;
  ln_sqrt_2pi: double;
begin
  ln_sqrt_2pi := ln(sqrt(2 * pi));                    // = ln(2 * pi) / 2;
  sum := 0;
  v := 1;
	while x < m do begin
    v := v * x;
    x := x + 1;
  end;
  xx := x * x;
  xj := x;
  lng := ln_sqrt_2pi - x + (x - 0.5) * ln(x) - ln(v);
  for i := 1 to  m do begin
    sum := sum + B[i] / (i * 2 * (2 * i - 1)) / xj;
    xj := xj * xx;
  end;
  result := exp(sum + lng);
end;

// (a, x)
function incomplete_gamma1(a, x: double): double;  // PsSK}֐
var
  k : integer;
  term, previous : double;
begin
  result := 0;
	if x = 0 then exit;
	term := exp(a * ln(x) - x) / a;
  result := term;
	for k := 1 to 1000 do begin
		term := term * x / (a + k);
		previous := result;
    result := result + term;
		if result = previous then begin
      exit;
    end;
	end;
	Form1.Memo1.Lines.add ('p_gamma(): ܂');
end;

// (a, x)
function incomplete_gamma2(a, x: double): double;           // QsSK}֐
var
  k : integer;
  w, temp, previous : double;
  la, lb : double;
begin
	if x < 1 + a then begin
    result := Gamma(a) - incomplete_gamma1(a, x);
    exit;
  end;
  la := 1;                        // Laguerrȇ
  lb := 1 + x - a;
	w := exp(a * ln(x) - x);
	result := w / lb;
	for k := 2  to 1000 do begin
		temp := ((k - 1 - a) * (lb - la) + (k + x) * lb) / k;
		la := lb;
    lb := temp;
		w := w * (k - 1 - a) / k;
		temp := w / (la * lb);
		previous := result;
    result := result + temp;
		if result = previous then exit;
	end;
	Form1.Memo1.Lines.add ('q_gamma: ܂');
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var
  ch : integer;
  x, a: double;
  GI, G  : double;
  MIN, MAX: double;
  dx     : double;
  i : integer;
begin
  val(LabeledEdit1.Text, x, Ch);
  if ch <> 0 then begin
    MessageDlg('x̒lɊԈႢ܂B', mtInformation,
      [mbOk], 0, mbOk);
    exit;
  end;
  if x < 0 then begin
    MessageDlg('x͌vZo܂', mtInformation,
      [mbOk], 0, mbOk);
    exit;
  end;
  val(LabeledEdit2.Text, a, Ch);
  if ch <> 0 then begin
    MessageDlg('a̒lɊԈႢ܂B', mtInformation,
      [mbOk], 0, mbOk);
    exit;
  end;
  if a <= 0 then begin
    MessageDlg('a̓[傫ĉvZo܂B', mtInformation,
      [mbOk], 0, mbOk);
    exit;
  end;
  GI := incomplete_gamma1(a, x);
  if checkbox1.Checked = false then
    G :=  gamma(a) - GI
  else
    G := incomplete_gamma2(a, x);
  Memo1.Clear;
  Memo1.Lines.Add('(' + floatTostr(a) + ',' + floatTostr(x) + ') = ');
  Memo1.Lines.Add('     ' + floatTostr(GI));
  Memo1.Lines.Add('(' + floatTostr(a) + ',' + floatTostr(x) + ') = ');
  Memo1.Lines.Add('     ' + floatTostr(G));
  Series1.Clear;
  Series2.Clear;
  Series3.Clear;
  Series4.Clear;
  Series3.AddXY(x, GI);
  Series4.AddXY(x, G);
  MIN := x / 20;
  MAX := MIN + x + 5;
  dx := (MAX - MIN) / 100;
  for i := 0 to 100 do begin
    x := dx * i + MIN;
    GI := incomplete_gamma1(a,  x);
    Series1.AddXY(x, GI);
    if checkbox1.Checked = false then
      G :=  gamma(a) - GI
    else
      G := incomplete_gamma2(a,  x);
    Series2.AddXY(x, G);
  end;
end;

end.
